namespace IceShock.ModalDialog
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for ModalDialogControl.
	/// </summary>
	public class ModalDialogControl : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Button refreshButton;
		protected string PostBackEvent = "";

		private void Page_Load(object sender, System.EventArgs e)
		{
			PostBackEvent = this.Page.GetPostBackClientEvent(this.refreshButton, "");
		}

		#region Members/Properties
		private string _DialogPage;
		private string _DialogWidth;
		private string _DialogHeight;

		public string DialogPage
		{
			get {return _DialogPage;}
			set {_DialogPage = value;}			
		}

		public string DialogHeight
		{
			get {return _DialogHeight;}
			set 
			{
				string s = value.ToString();
				for(int i = 0;i < s.Length; i++)
				{
					if(!Char.IsDigit(s, i))
						throw new System.ArgumentException("the provided parameter is not numeric", "Height");
				}
				_DialogHeight = value;
				
			}
		}

		public string DialogWidth
		{
			get {return _DialogWidth;}
			set 
			{
				string s = value.ToString();
				for(int i = 0;i < s.Length; i++)
				{
					if(!Char.IsDigit(s, i))
						throw new System.ArgumentException("the provided parameter is not numeric", "Width");
				}
				_DialogWidth = value;
			}
		}
		#endregion


		#region "Dialog Event"
		

		

		public delegate void DialogCommandEventHandler(object sender,EventArgs e);
		public event DialogCommandEventHandler DialogFinished;

		protected virtual void OnDialogFinished(EventArgs e)
		{
			if(DialogFinished != null) DialogFinished(this, e);
		}

		

		#endregion



		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void refreshButton_Click(object sender, System.EventArgs e)
		{
			OnDialogFinished(e);
		}

		public void show()
		{
			Page.RegisterStartupScript("dialogScript", @"<script>
								function popupLoader()
								{
									showPopWin('" + DialogPage + "', " + DialogWidth + ", " + DialogHeight + @", PostBackMethod);
								}
								var prev_onload = window.onload;//careful not to have other vars with same name
								window.onload = function() {
																initPopUp();
																popupLoader();
																
																if(prev_onload)
																	return prev_onload();
																else
																	return true;
															};
								
							</script>");
		}
		public void ShowAlert(string text)
		{
			this._DialogHeight = "100";
			this._DialogWidth = "400";
			this._DialogPage = "AlertPage.aspx?Text=" + Server.UrlEncode(text);
			this.show();
		}
		public void showConfirm(string text)
		{
			this._DialogHeight = "100";
			this._DialogWidth = "400";
			this._DialogPage = "ConfirmPage.aspx?Text=" + Server.UrlEncode(text);
			this.show();
		}

	}
}
